package controllers

import "hongze/hongze_api/models"

type ClassifyController struct {
	BaseAuthController
}

// @Title 获取分类详情信息
// @Description 获取分类详情信息接口
// @Param   ClassifyId   query   int  true       "分类id"
// @Success 200 {object} models.Banner
// @router /detail [get]
func (this *ClassifyController) Detail() {
	br := new(models.BaseResponse).Init()
	defer func() {
		this.Data["json"] = br
		this.ServeJSON()
	}()
	classifyId, err := this.GetInt("ClassifyId")
	if err != nil {
		br.Msg = "参数获取失败"
		br.ErrMsg = "参数获取失败，Err:" + err.Error()
		return
	}
	if classifyId <= 0 {
		br.Msg = "参数错误"
		br.ErrMsg = "参数错误，分类id小于等于0"
		return
	}
	item, err := models.GetClassifyById(classifyId)
	if err != nil {
		br.Msg = "获取信息失败"
		br.ErrMsg = "获取信息失败,Err:" + err.Error()
		return
	}
	br.Ret = 200
	br.Success = true
	br.Msg = "获取数据成功"
	br.Data = item
}
